package com.hai.dao;

import com.hai.entity.HighMerchant;
import com.hai.entity.HighMerchantExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighMerchantMapper extends HighMerchantMapperExt {
    @SelectProvider(type=HighMerchantSqlProvider.class, method="countByExample")
    long countByExample(HighMerchantExample example);

    @DeleteProvider(type=HighMerchantSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighMerchantExample example);

    @Delete({
        "delete from high_merchant",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_merchant (company_id, merchant_key, ",
        "merchant_name, merchant_logo, ",
        "merchant_desc, telephone, ",
        "bank_name, bank_account, ",
        "bank_holder, address, ",
        "`status`, operator_id, ",
        "operator_name, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{companyId,jdbcType=BIGINT}, #{merchantKey,jdbcType=VARCHAR}, ",
        "#{merchantName,jdbcType=VARCHAR}, #{merchantLogo,jdbcType=VARCHAR}, ",
        "#{merchantDesc,jdbcType=VARCHAR}, #{telephone,jdbcType=VARCHAR}, ",
        "#{bankName,jdbcType=VARCHAR}, #{bankAccount,jdbcType=VARCHAR}, ",
        "#{bankHolder,jdbcType=VARCHAR}, #{address,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{operatorId,jdbcType=BIGINT}, ",
        "#{operatorName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighMerchant record);

    @InsertProvider(type=HighMerchantSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighMerchant record);

    @SelectProvider(type=HighMerchantSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="merchant_key", property="merchantKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="merchant_name", property="merchantName", jdbcType=JdbcType.VARCHAR),
        @Result(column="merchant_logo", property="merchantLogo", jdbcType=JdbcType.VARCHAR),
        @Result(column="merchant_desc", property="merchantDesc", jdbcType=JdbcType.VARCHAR),
        @Result(column="telephone", property="telephone", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_name", property="bankName", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_account", property="bankAccount", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_holder", property="bankHolder", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighMerchant> selectByExample(HighMerchantExample example);

    @Select({
        "select",
        "id, company_id, merchant_key, merchant_name, merchant_logo, merchant_desc, telephone, ",
        "bank_name, bank_account, bank_holder, address, `status`, operator_id, operator_name, ",
        "create_time, update_time, ext_1, ext_2, ext_3",
        "from high_merchant",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="merchant_key", property="merchantKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="merchant_name", property="merchantName", jdbcType=JdbcType.VARCHAR),
        @Result(column="merchant_logo", property="merchantLogo", jdbcType=JdbcType.VARCHAR),
        @Result(column="merchant_desc", property="merchantDesc", jdbcType=JdbcType.VARCHAR),
        @Result(column="telephone", property="telephone", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_name", property="bankName", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_account", property="bankAccount", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_holder", property="bankHolder", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighMerchant selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighMerchantSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighMerchant record, @Param("example") HighMerchantExample example);

    @UpdateProvider(type=HighMerchantSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighMerchant record, @Param("example") HighMerchantExample example);

    @UpdateProvider(type=HighMerchantSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighMerchant record);

    @Update({
        "update high_merchant",
        "set company_id = #{companyId,jdbcType=BIGINT},",
          "merchant_key = #{merchantKey,jdbcType=VARCHAR},",
          "merchant_name = #{merchantName,jdbcType=VARCHAR},",
          "merchant_logo = #{merchantLogo,jdbcType=VARCHAR},",
          "merchant_desc = #{merchantDesc,jdbcType=VARCHAR},",
          "telephone = #{telephone,jdbcType=VARCHAR},",
          "bank_name = #{bankName,jdbcType=VARCHAR},",
          "bank_account = #{bankAccount,jdbcType=VARCHAR},",
          "bank_holder = #{bankHolder,jdbcType=VARCHAR},",
          "address = #{address,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighMerchant record);
}