package com.hai.service.impl;

import com.hai.dao.BsDistributionUserRelMapper;
import com.hai.entity.*;
import com.hai.service.*;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service("bsDistributionUserRelService")
public class BsDistributionUserRelServiceImpl implements BsDistributionUserRelService {

    @Resource
    private BsDistributionUserRelMapper  bsDistributionUserRelMapper;

    @Resource
    private HighDiscountPackageService highDiscountPackageService;

    @Resource
    private HighUserService highUserService;

    @Resource
    private BsCompanyService bsCompanyService;

    @Resource
    private CommonService commonService;


    @Override
    public void insertDistributionRebate(Long userId, Long popularizeUserId , String regionId) {

        HighUser user = highUserService.findByUserId(userId);
        HighUser pUser = highUserService.findByUserId(popularizeUserId);

        // 定义分销关联关系
        BsDistributionUserRel distributionUserRel = new BsDistributionUserRel();

        // 查询推广员信息
        Map<String, Object> map = new HashMap<>();
        map.put("userId" , popularizeUserId);

        BsDistributionUserRel popularizeUser = findDistributionUserRel(map);

        if (popularizeUser != null) {
            distributionUserRel.setAgentId(popularizeUser.getAgentId());
            distributionUserRel.setAgentName(popularizeUser.getAgentName());
        }

        distributionUserRel.setUserId(userId);
        distributionUserRel.setUserName(user.getName());
        distributionUserRel.setPopularizeUserId(popularizeUserId);
        distributionUserRel.setPopularizeUserName(pUser.getName());
        distributionUserRel.setCreateTime(new Date());
        distributionUserRel.setUpdateTime(new Date());
        distributionUserRel.setStatus(100);

        bsDistributionUserRelMapper.insert(distributionUserRel);

        new Thread(() -> {

            try {

                SecRegion region = commonService.getParentByRegion(Long.valueOf(regionId));
                BsCompany bsCompany = bsCompanyService.selectCompanyByRegion(region.getRegionId().toString());

                // 查询注册有礼优惠券包
                HighDiscountPackage discountPackage = highDiscountPackageService.getCallExclusive(3 , bsCompany.getId().intValue());
                Map<String, Object> freeMap = new HashMap<>();
                freeMap.put("discountPackageId", discountPackage.getId());
                freeMap.put("userId", userId);
                freeMap.put("userPhone", user.getPhone());
                highDiscountPackageService.freeUserDiscountPackage(freeMap);

                // 查询推广有礼优惠券包
                HighDiscountPackage promoteDiscountPackage = highDiscountPackageService.getCallExclusive(4 , bsCompany.getId().intValue());
                Map<String, Object> freeMap1 = new HashMap<>();
                freeMap1.put("discountPackageId", promoteDiscountPackage.getId());
                freeMap1.put("userId", userId);
                freeMap1.put("userPhone", user.getPhone());
                highDiscountPackageService.freeUserDiscountPackage(freeMap1);
            } catch (Exception e) {
                e.printStackTrace();
            }

        }).start();

    }

    @Override
    public List<BsDistributionUserRel> getDistributionUserRelList(Map<String, Object> map) {
        return null;
    }

    @Override
    public BsDistributionUserRel findDistributionUserRel(Map<String, Object> map) {

        BsDistributionUserRelExample example = new BsDistributionUserRelExample();
        BsDistributionUserRelExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(map , "userId") != null) {
            criteria.andUserIdEqualTo(MapUtils.getLong(map , "userId"));
        }

        List<BsDistributionUserRel> list = bsDistributionUserRelMapper.selectByExample(example);

        if (list.size() > 0) {
            return list.get(0);
        }

        return null;
    }
}
